Module ij
Package ij

# Class Prefs

java.lang.Object
ij.Prefs

public class Prefs extends Object
This class contains the ImageJ preferences, which are loaded from the "IJ_Props.txt" and "IJ_Prefs.txt" files.

See Also:
  - `ImageJ`

## Field Summary

Fields
Modifier and Type
Field
Description
`static boolean`
`alwaysOnTop`
"ImageJ" window is always on top.
`static boolean`
`antialiasedText`
No longer used
`static boolean`
`antialiasedTools`
Draw tool icons using antialiasing (always true).
`static boolean`
`autoContrast`
Adjust contrast when scrolling stacks
`static boolean`
`autoLivePlots`
Turn live display on plots automatically
`static boolean`
`autoRunExamples`
Automatically run examples in Help/Examples menu.
`static boolean`
`avoidResliceInterpolation`
Avoid interpolation when re-slicing
`static final String`
`BCOLOR`
`static boolean`
`blackBackground`
Backgound is black in binary images
`static boolean`
`blackCanvas`
Use black image border.
`static boolean`
`calibrateConversions`
Calibrate image type conversions
`static boolean`
`closingAll`
"Close All" command running
`static boolean`
`convertToMicrons`
Convert tiff units to microns if pixel width is less than 0.0001 cm.
`static boolean`
`copyColumnHeaders`
Include column headers when copying tables to clipboard.
`static boolean`
`dialogCancelButtonOnRight`
Dialog "Cancel" button is on right on Linux
`static final String`
`DIR_IMAGE`
`static boolean`
`disableUndo`
Disable Edit/Undo command.
`static final String`
`DIV_BY_ZERO_VALUE`
`static boolean`
`doNotSaveWindowLocations`
Enable this option to workaround a bug with some Linux window managers that causes windows to wander down the screen.
`static boolean`
`dontSaveHeaders`
Don't save Results table column headers
`static boolean`
`dontSaveRowNumbers`
Don't save Results table row numbers
`static boolean`
`doubleBuffer`
No longer used
`static boolean`
`enhancedLineTool`
Allow lines to be created with one click at start and another at the end
`static final String`
`FCOLOR`
`static boolean`
`fixedDicomScaling`
Assume DICOM volumes use identical RescaleSlope and RescaleIntercept across all slices
`static boolean`
`flipXZ`
Rotate XZ orthogonal views 180 degrees
`static final String`
`FPS`
`static boolean`
`fullRange16bitInversions`
Use full range for 16-bit inversions
`static final String`
`GUI_SCALE`
`static boolean`
`ignoreRescaleSlope`
Ignore Rescale Slope when opening DICOMs
`static boolean`
`intelByteOrder`
Export TIFF and Raw using little-endian byte order.
`static boolean`
`interpolateScaledImages`
Display images scaled invalid input: '<'100% using bilinear interpolation
`static boolean`
`jFileChooserSettingChanged`
Use JFileChooser setting changed/
`static final String`
`JPEG`
`static boolean`
`keepArrowSelections`
Keep arrow selection after adding to overlay
`static boolean`
`keepUndoBuffers`
Preserve undo (snapshot) buffers when switching images
`static final String`
`KEY_PREFIX`
`static final String`
`MENU_SIZE`
`static boolean`
`moveToMisc`
Move isolated plugins to Miscellaneous submenu.
`static boolean`
`multiPointMode`
Use MultiPoint tool.
`static boolean`
`noBorder`
Do not draw black border around image.
`static boolean`
`noClickToGC`
Don't run garbage collector when user clicks in status bar
`static final String`
`NOISE_SD`
`static boolean`
`nonBlockingFilterDialogs`
Use NonBlockingGenericDialogs in filters
`static boolean`
`noPointLabels`
Do not label multiple points created using point tool.
`static boolean`
`noRowNumbers`
Do not include row numbers when copying tables to clipboard.
`static boolean`
`open100Percent`
Open images at 100% magnification
`static boolean`
`openDicomsAsFloat`
Open DICOMs as 32-bit float images
`static final String`
`OPTIONS`
`static final String`
`OPTIONS2`
`static boolean`
`padEdges`
Extend the borders to foreground for binary erosions and closings.
`static boolean`
`paintDoubleBuffered`
Aways paint images using double buffering
`static boolean`
`pointAddToManager`
Add points to ROI Manager.
`static boolean`
`pointAddToOverlay`
Add points to overlay.
`static boolean`
`pointAutoMeasure`
Point tool auto-measure mode.
`static boolean`
`pointAutoNextSlice`
Point tool auto-next slice mode (not saved in IJ_Prefs).
`static final String`
`PREFS_NAME`
`static final String`
`PROPS_NAME`
`static boolean`
`reflexAngle`
Angle tool measures reflex angle
`static boolean`
`requireControlKey`
Require control or command key for keybaord shortcuts.
`static boolean`
`reverseNextPreviousOrder`
Reverse channel-slice-frame priority used by Next Slice and Previous Slice commands.
`static final String`
`ROICOLOR`
`static boolean`
`rotateYZ`
Rotate YZ orthogonal views 90 degrees
`static boolean`
`runSocketListener`
Run the SocketListener.
`static String`
`separator`
file.separator system property
`static boolean`
`setIJMenuBar`
Set MenuBar on Macs running Java 8.
`static final String`
`SHOW_ALL_COLOR`
`static boolean`
`showAllPoints`
Ignore stack positions when displaying points.
`static boolean`
`showAllSliceOnly`
Only show ROIs associated with current slice in Roi Manager "Show All" mode.
`static boolean`
`skipRawDialog`
Do not display dialog when opening .raw files
`static boolean`
`smoothWand`
Wand tool "Smooth if thresholded" option
`static boolean`
`splineFitLines`
Automatically spline fit line selections
`static boolean`
`subPixelResolution`
Use sub-pixel resolution with line selections
`static boolean`
`supportMacroUndo`
Support TRANSFORM Undo in macros
`static final String`
`THREADS`
`static boolean`
`useFileChooser`
Use the file chooser to import and export image sequences on Windows and Linux
`static boolean`
`useInvertingLut`
Open 8-bit images with inverting LUT so 0 is white and 255 is black.
`static boolean`
`useJFileChooser`
Use JFileChooser instead of FileDialog to open and save files.
`static boolean`
`useNamesAsLabels`
Use ROI names as "show all" labels in the ROI Manager
`static boolean`
`usePointerCursor`
Use pointer cursor instead of cross
`static boolean`
`useSystemProxies`
Set the "java.net.useSystemProxies" property
`static boolean`
`verticalProfile`
Plot rectangular selectons vertically
`static final String`
`vistaHint`
`static boolean`
`weightedColor`
Color to grayscale conversion is weighted (0.299, 0.587, 0.114) if the variable is true.

## Constructor Summary

Constructors
Constructor
Description
`Prefs()`

## Method Summary

Modifier and Type
Method
Description
`static boolean`
`commandLineMacro()`
`static String`
`defaultResultsExtension()`
`static boolean`
`get(String key, boolean defaultValue)`
Uses the keyword `key` to retrieve a boolean from the preferences file.
`static double`
`get(String key, double defaultValue)`
Uses the keyword `key` to retrieve a number from the preferences file.
`static String`
`get(String key, String defaultValue)`
Uses the keyword `key` to retrieve a string from the preferences file.
`static boolean`
`getBoolean(String key, boolean defaultValue)`
Retrieves a boolean from IJ_Props or IJ_Prefs.txt.
`static Color`
`getColor(String key, Color defaultColor)`
Finds a color in IJ_Props or IJ_Prefs.txt.
`static Properties`
`getControlPanelProperties()`
`static String`
`getCustomPrefsPath()`
Returns the custom preferences (IJ_Prefs.txt) file path.
`static String`
`getCustomPropsPath()`
Returns the custom properties (IJ_Props.txt) file path.
`static String`
`getDefaultDirectory()`
Returns the default directory, if any, or null.
`static double`
`getDouble(String key, double defaultValue)`
Retrieves a number from IJ_Props or IJ_Prefs.txt.
`static String`
`getFileSeparator()`
Returns the file.separator system property.
`static double`
`getGuiScale()`
Returns the GenericDialog and Command Finder text scale.
`static String`
`getHomeDir()`
Obsolete, replaced by getImageJDir(), which, unlike this method, returns a path that ends with File.separator.
`static String`
`getImageJDir()`
Returns the path, ending in File.separator, to the ImageJ directory.
`static String`
`getImagesURL()`
Returns the URL of the directory that contains the ImageJ sample images.
`static int`
`getInt(String key, int defaultValue)`
Retrieves a number from IJ_Props or IJ_Prefs.txt.
`static Point`
`getLocation(String key)`
Uses the keyword `key` to retrieve a location from the preferences file.
`static String`
`getPluginsDirProperty()`
`static String`
`getPrefsDir()`
Returns the path to the directory where the preferences file (IJPrefs.txt) is saved.
`static String`
`getString(String key)`
Retrieves a string from string in IJ_Props or IJ_Prefs.txt.
`static String`
`getString(String key, String defaultString)`
Retrieves a string from IJ_Props or IJ_Prefs.txt.
`static int`
`getThreads()`
Returns the number of threads used by PlugInFilters to process images and stacks.
`static int`
`getTransparentIndex()`
Returns the transparent index (0-255), or -1 if transparency is disabled.
`static String`
`load(Object ij, Applet applet)`
Finds and loads the configuration file ("IJ_Props.txt") and the preferences file ("IJ_Prefs.txt").
`static void`
`resetPreferences()`
Delete the preferences file when ImageJ quits.
`static void`
`saveLocation(String key, Point loc)`
Saves the Point `loc` in the preferences file as a string using the keyword `key`.
`static void`
`savePreferences()`
Saves user preferences in the IJ_Prefs.txt properties file.
`static void`
`savePrefs(Properties prefs, String path)`
`static void`
`set(String key, boolean value)`
Saves the value of the boolean `value` in the preferences file using the keyword `key`.
`static void`
`set(String key, double value)`
Saves the value of the double `value` in the preferences file using the keyword `key`.
`static void`
`set(String key, int value)`
Saves the value of the integer `value` in the preferences file using the keyword `key`.
`static void`
`set(String key, String text)`
Saves the value of the string `text` in the preferences file using the keyword `key`.
`static void`
`setGuiScale(double scale)`
Sets the GenericDialog and Command Finder text scale (0.5 to 3.0).
`static void`
`setImagesURL(String url)`
Sets the URL of the directory that contains the ImageJ sample images.
`static void`
`setThreads(int n)`
Sets the number of threads (1-32) used by PlugInFilters to process stacks.
`static void`
`setTransparentIndex(int index)`
Sets the transparent index (0-255), or set to -1 to disable transparency.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### PROPS_NAME

public static final String PROPS_NAME

See Also:
  - Constant Field Values

### PREFS_NAME

public static final String PREFS_NAME

See Also:
  - Constant Field Values

### DIR_IMAGE

public static final String DIR_IMAGE

See Also:
  - Constant Field Values

### FCOLOR

public static final String FCOLOR

See Also:
  - Constant Field Values

### BCOLOR

public static final String BCOLOR

See Also:
  - Constant Field Values

### ROICOLOR

public static final String ROICOLOR

See Also:
  - Constant Field Values

### SHOW_ALL_COLOR

public static final String SHOW_ALL_COLOR

See Also:
  - Constant Field Values

### JPEG

public static final String JPEG

See Also:
  - Constant Field Values

### FPS

public static final String FPS

See Also:
  - Constant Field Values

### DIV_BY_ZERO_VALUE

public static final String DIV_BY_ZERO_VALUE

See Also:
  - Constant Field Values

### NOISE_SD

public static final String NOISE_SD

See Also:
  - Constant Field Values

### MENU_SIZE

public static final String MENU_SIZE

See Also:
  - Constant Field Values

### GUI_SCALE

public static final String GUI_SCALE

See Also:
  - Constant Field Values

### THREADS

public static final String THREADS

See Also:
  - Constant Field Values

### KEY_PREFIX

public static final String KEY_PREFIX

See Also:
  - Constant Field Values

### OPTIONS

public static final String OPTIONS

See Also:
  - Constant Field Values

### vistaHint

public static final String vistaHint

See Also:
  - Constant Field Values

### OPTIONS2

public static final String OPTIONS2

See Also:
  - Constant Field Values

### separator

public static String separator
file.separator system property

### usePointerCursor

public static boolean usePointerCursor
Use pointer cursor instead of cross

### antialiasedText

public static boolean antialiasedText
No longer used

### interpolateScaledImages

public static boolean interpolateScaledImages
Display images scaled invalid input: '<'100% using bilinear interpolation

### open100Percent

public static boolean open100Percent
Open images at 100% magnification

### blackBackground

public static boolean blackBackground
Backgound is black in binary images

### useJFileChooser

public static boolean useJFileChooser
Use JFileChooser instead of FileDialog to open and save files.

### weightedColor

public static boolean weightedColor
Color to grayscale conversion is weighted (0.299, 0.587, 0.114) if the variable is true.

### blackCanvas

public static boolean blackCanvas
Use black image border.

### pointAutoMeasure

public static boolean pointAutoMeasure
Point tool auto-measure mode.

### pointAutoNextSlice

public static boolean pointAutoNextSlice
Point tool auto-next slice mode (not saved in IJ_Prefs).

### requireControlKey

public static boolean requireControlKey
Require control or command key for keybaord shortcuts.

### useInvertingLut

public static boolean useInvertingLut
Open 8-bit images with inverting LUT so 0 is white and 255 is black.

### antialiasedTools

public static boolean antialiasedTools
Draw tool icons using antialiasing (always true).

### intelByteOrder

public static boolean intelByteOrder
Export TIFF and Raw using little-endian byte order.

### doubleBuffer

public static boolean doubleBuffer
No longer used

### noPointLabels

public static boolean noPointLabels
Do not label multiple points created using point tool.

### disableUndo

public static boolean disableUndo
Disable Edit/Undo command.

### noBorder

public static boolean noBorder
Do not draw black border around image.

### showAllSliceOnly

public static boolean showAllSliceOnly
Only show ROIs associated with current slice in Roi Manager "Show All" mode.

### copyColumnHeaders

public static boolean copyColumnHeaders
Include column headers when copying tables to clipboard.

### noRowNumbers

public static boolean noRowNumbers
Do not include row numbers when copying tables to clipboard.

### moveToMisc

public static boolean moveToMisc
Move isolated plugins to Miscellaneous submenu.

### pointAddToManager

public static boolean pointAddToManager
Add points to ROI Manager.

### pointAddToOverlay

public static boolean pointAddToOverlay
Add points to overlay.

### padEdges

public static boolean padEdges
Extend the borders to foreground for binary erosions and closings.

### runSocketListener

public static boolean runSocketListener
Run the SocketListener.

### multiPointMode

public static boolean multiPointMode
Use MultiPoint tool.

### openDicomsAsFloat

public static boolean openDicomsAsFloat
Open DICOMs as 32-bit float images

### ignoreRescaleSlope

public static boolean ignoreRescaleSlope
Ignore Rescale Slope when opening DICOMs

### fixedDicomScaling

public static boolean fixedDicomScaling
Assume DICOM volumes use identical RescaleSlope and RescaleIntercept across all slices

### verticalProfile

public static boolean verticalProfile
Plot rectangular selectons vertically

### rotateYZ

public static boolean rotateYZ
Rotate YZ orthogonal views 90 degrees

### flipXZ

public static boolean flipXZ
Rotate XZ orthogonal views 180 degrees

### dontSaveHeaders

public static boolean dontSaveHeaders
Don't save Results table column headers

### dontSaveRowNumbers

public static boolean dontSaveRowNumbers
Don't save Results table row numbers

### noClickToGC

public static boolean noClickToGC
Don't run garbage collector when user clicks in status bar

### reflexAngle

public static boolean reflexAngle
Angle tool measures reflex angle

### avoidResliceInterpolation

public static boolean avoidResliceInterpolation
Avoid interpolation when re-slicing

### keepUndoBuffers

public static boolean keepUndoBuffers
Preserve undo (snapshot) buffers when switching images

### useNamesAsLabels

public static boolean useNamesAsLabels
Use ROI names as "show all" labels in the ROI Manager

### useSystemProxies

public static boolean useSystemProxies
Set the "java.net.useSystemProxies" property

### useFileChooser

public static boolean useFileChooser
Use the file chooser to import and export image sequences on Windows and Linux

### subPixelResolution

public static boolean subPixelResolution
Use sub-pixel resolution with line selections

### autoContrast

public static boolean autoContrast
Adjust contrast when scrolling stacks

### enhancedLineTool

public static boolean enhancedLineTool
Allow lines to be created with one click at start and another at the end

### keepArrowSelections

public static boolean keepArrowSelections
Keep arrow selection after adding to overlay

### paintDoubleBuffered

public static boolean paintDoubleBuffered
Aways paint images using double buffering

### skipRawDialog

public static boolean skipRawDialog
Do not display dialog when opening .raw files

### reverseNextPreviousOrder

public static boolean reverseNextPreviousOrder
Reverse channel-slice-frame priority used by Next Slice and Previous Slice commands.

### autoRunExamples

public static boolean autoRunExamples
Automatically run examples in Help/Examples menu.

### showAllPoints

public static boolean showAllPoints
Ignore stack positions when displaying points.

### setIJMenuBar

public static boolean setIJMenuBar
Set MenuBar on Macs running Java 8.

### alwaysOnTop

public static boolean alwaysOnTop
"ImageJ" window is always on top.

### splineFitLines

public static boolean splineFitLines
Automatically spline fit line selections

### doNotSaveWindowLocations

public static boolean doNotSaveWindowLocations
Enable this option to workaround a bug with some Linux window managers that causes windows to wander down the screen.

### jFileChooserSettingChanged

public static boolean jFileChooserSettingChanged
Use JFileChooser setting changed/

### convertToMicrons

public static boolean convertToMicrons
Convert tiff units to microns if pixel width is less than 0.0001 cm.

### smoothWand

public static boolean smoothWand
Wand tool "Smooth if thresholded" option

### closingAll

public static boolean closingAll
"Close All" command running

### dialogCancelButtonOnRight

public static boolean dialogCancelButtonOnRight
Dialog "Cancel" button is on right on Linux

### supportMacroUndo

public static boolean supportMacroUndo
Support TRANSFORM Undo in macros

### nonBlockingFilterDialogs

public static boolean nonBlockingFilterDialogs
Use NonBlockingGenericDialogs in filters

### autoLivePlots

public static boolean autoLivePlots
Turn live display on plots automatically

### fullRange16bitInversions

public static boolean fullRange16bitInversions
Use full range for 16-bit inversions

### calibrateConversions

public static boolean calibrateConversions
Calibrate image type conversions

## Constructor Details

### Prefs

public Prefs()

## Method Details

### set

public static void set(String key, String text)
Saves the value of the string `text` in the preferences file using the keyword `key`. The string can be retrieved using the appropriate `get()` method.

See Also:
  - `get(String,String)`

### set

public static void set(String key, int value)
Saves the value of the integer `value` in the preferences file using the keyword `key`. The value can be retrieved using the appropriate `get()` method.

See Also:
  - `get(String,double)`

### set

public static void set(String key, double value)
Saves the value of the double `value` in the preferences file using the keyword `key`. The value can be retrieved using the appropriate `get()` method.

See Also:
  - `get(String,double)`

### set

public static void set(String key, boolean value)
Saves the value of the boolean `value` in the preferences file using the keyword `key`. The value can be retrieved using the appropriate `get()` method.

See Also:
  - `get(String,boolean)`

### get

public static String get(String key, String defaultValue)
Uses the keyword `key` to retrieve a string from the preferences file. Returns `defaultValue` if the key is not found.

### get

public static double get(String key, double defaultValue)
Uses the keyword `key` to retrieve a number from the preferences file. Returns `defaultValue` if the key is not found.

### get

public static boolean get(String key, boolean defaultValue)
Uses the keyword `key` to retrieve a boolean from the preferences file. Returns `defaultValue` if the key is not found.

### load

public static String load(Object ij, Applet applet)
Finds and loads the configuration file ("IJ_Props.txt") and the preferences file ("IJ_Prefs.txt").

Returns:
  an error message if "IJ_Props.txt" not found.

### getImagesURL

public static String getImagesURL()
Returns the URL of the directory that contains the ImageJ sample images.

### setImagesURL

public static void setImagesURL(String url)
Sets the URL of the directory that contains the ImageJ sample images.

### getHomeDir

public static String getHomeDir()
Obsolete, replaced by getImageJDir(), which, unlike this method, returns a path that ends with File.separator.

### getImageJDir

public static String getImageJDir()
Returns the path, ending in File.separator, to the ImageJ directory.

### getPluginsDirProperty

public static String getPluginsDirProperty()

### getPrefsDir

public static String getPrefsDir()
Returns the path to the directory where the preferences file (IJPrefs.txt) is saved.

### getDefaultDirectory

public static String getDefaultDirectory()
Returns the default directory, if any, or null.

### getFileSeparator

public static String getFileSeparator()
Returns the file.separator system property.

### savePreferences

public static void savePreferences()
Saves user preferences in the IJ_Prefs.txt properties file.

### resetPreferences

public static void resetPreferences()
Delete the preferences file when ImageJ quits.

### saveLocation

public static void saveLocation(String key, Point loc)
Saves the Point `loc` in the preferences file as a string using the keyword `key`.

### getLocation

public static Point getLocation(String key)
Uses the keyword `key` to retrieve a location from the preferences file. Returns null if the key is not found or the location is not valid (e.g., offscreen).

### savePrefs

public static void savePrefs(Properties prefs, String path) throws IOException

Throws:
  `IOException`

### getThreads

public static int getThreads()
Returns the number of threads used by PlugInFilters to process images and stacks.

### setThreads

public static void setThreads(int n)
Sets the number of threads (1-32) used by PlugInFilters to process stacks.

### setTransparentIndex

public static void setTransparentIndex(int index)
Sets the transparent index (0-255), or set to -1 to disable transparency.

### getTransparentIndex

public static int getTransparentIndex()
Returns the transparent index (0-255), or -1 if transparency is disabled.

### getControlPanelProperties

public static Properties getControlPanelProperties()

### defaultResultsExtension

public static String defaultResultsExtension()

### setGuiScale

public static void setGuiScale(double scale)
Sets the GenericDialog and Command Finder text scale (0.5 to 3.0).

### getGuiScale

public static double getGuiScale()
Returns the GenericDialog and Command Finder text scale.

### getCustomPropsPath

public static String getCustomPropsPath()
Returns the custom properties (IJ_Props.txt) file path.

### getCustomPrefsPath

public static String getCustomPrefsPath()
Returns the custom preferences (IJ_Prefs.txt) file path.

### getString

public static String getString(String key, String defaultString)
Retrieves a string from IJ_Props or IJ_Prefs.txt. Does not retrieve strings set using Prefs.set().

### getString

public static String getString(String key)
Retrieves a string from string in IJ_Props or IJ_Prefs.txt.

### getInt

public static int getInt(String key, int defaultValue)
Retrieves a number from IJ_Props or IJ_Prefs.txt. Does not retrieve numbers set using Prefs.set().

### getDouble

public static double getDouble(String key, double defaultValue)
Retrieves a number from IJ_Props or IJ_Prefs.txt. Does not retrieve numbers set using Prefs.set().

### getBoolean

public static boolean getBoolean(String key, boolean defaultValue)
Retrieves a boolean from IJ_Props or IJ_Prefs.txt. Does not retrieve boolean set using Prefs.set().

### getColor

public static Color getColor(String key, Color defaultColor)
Finds a color in IJ_Props or IJ_Prefs.txt.

### commandLineMacro

public static boolean commandLineMacro()